#include<cstdio>
#include<cstring>
#include<algorithm>
#include<cmath>
#include<iostream>
#include<vector>
#include<random>
using namespace std;
const int N = 4941;
const int dim = 3;
const double eta = 7;
struct demand {
	int t;
	double x[dim + 1];
	double predict[dim + 1];
	double r;
}D[N + 1];
double cost = 0;
const double eps = 1e-7;
int total_f = 0;
vector<int> Fset;
vector<int> T;
vector<demand> tmp;
vector<demand> g[7000];
default_random_engine e; 
demand err[7000];
double dis[N + 1][N + 1];
int P[N + 1];


int check(int x) {
	int siz = Fset.size();
	for (int j = 0; j < siz; j++) {
		if (Fset[j] == x)
			return j;
	}
	return -1;
}

inline double dist(demand &d1, demand &d2) {
	double ret = 0;
	for (int i = 1; i <= dim; i++)
		ret += (d1.x[i] - d2.x[i]) * (d1.x[i] - d2.x[i]);
	return sqrt(ret);
}


bool cmp(const demand &d1, const demand &d2) {
	return d1.r > d2.r;
}

int main() {
	
	freopen("USpowerGrid.txt", "r", stdin);
	for (int i = 1; i <= N; i++) 
		for (int j = i + 1; j <= N; j++) {
			int a, b, c;
			scanf("%d %d %d", &a, &b, &c);
			dis[a][b] = dis[b][a] = c;
		}
			
	freopen("USpowerGrid10.txt", "r", stdin); // P[pos] means the prediction of the pos-th demands.
	for (int i = 1; i <= N; i++) {
		int pos = 0;
		scanf("%d", &pos);
		scanf("%d", &P[pos]);
		if (check(P[pos]) == -1) 
			Fset.push_back(P[pos]);
	}
	/*int siz = Fset.size();
	for (int i = 0; i < siz; i++) 
		for (int j = 1; j <= dim; j++) {
			double r = u(e);
			if (r * 2 < eta)
				r = r * 2;
			err[i].x[j] = r;
		}
	freopen("twitter100_order.txt","w", stdout);
	for (int i = 1; i <= N; i++) {
		for (int k = 1; k <= dim; k++)
			printf(" %.6lf", D[i].x[k]);
		puts("");
	}
	freopen("twitter100_order_predict.txt", "w", stdout);
	for (int i = 1; i <= N; i++) {
		int id = check(P[i]);
		for (int k = 1; k <= dim; k++)
			printf("%.6lf ", P[i].x[k]+ err[id].x[k]);
		puts("");
	}*/

	freopen("USpowerGrid15_order.txt", "w", stdout); // change the order of demands
	for (int i = 1; i <= N; i++) {
		D[i].r = dis[i][P[i]];
		D[i].t = i;
		cost += D[i].r;
		int id = check(P[i]);
		g[id].push_back(D[i]);
	}
	int siz = Fset.size();
	for (int i = 0; i < siz; i++) {
		sort(g[i].begin(), g[i].end(), cmp);
		//cerr << g[i][0].r << endl; 
		for (int j = 0; j < g[i].size(); j++) {
			printf("%d\n", g[i][j].t);
			//cost += g[i][j].r;
		}
	}
	freopen("USpowerGrid15_order_predict.txt", "w", stdout); //generate prediction 
	for (int i = 0; i < siz; i++) {
		int tmp = Fset[i];
		T.clear();
		for (int j = N; j >= 1; j--)
			if (dis[Fset[i]][j] <= eta && dis[Fset[i]][j] >= eta / 2) {
				T.push_back(j);
			}
		tmp = T[rand() % T.size()];
		for (int j = 0; j < g[i].size(); j++) {
			printf("%d\n", tmp);
		}
	}
	return 0;
}